unit Abstraction;

interface

const
  WorkSegmentation = 100;     //the size of a job unit for a worker
  dfValuesSize     = 4000;
  dfWorkersCount   = 4;
  dfWastingLevel   = 32;      //how many excessive instruction-blocks to execute

type
  PValue = ^TValue;
  TValue = integer;           //whatever you like, with wasting, int is enough

  TAFarmer = class
    //The abstract farmer - methods visible to workers.
  public
    function AskForValues(out Values:PValue;
                          out ALimit:PValue):boolean; virtual; abstract;
      //Returns true if the caller has to compute,
      //or false if the caller has to terminate.
      //Values is the first value, ALimit is the last value.

    procedure ReportSum(ASum:TValue); virtual; abstract;
      //To report a sum of values assigned with AskForValues.

    procedure LogMessage(const AMessage:String); virtual; abstract;
      //Self-explaining:-)

    procedure AddWorkerRef; virtual; abstract;
    procedure ReleaseWorker; virtual; abstract;
      //worker counting aka reference counting 
  end;

implementation

end.
