//An application demonstrating the farmer-worker model with WinAPI.
//KIV/PPR Example.

//It generates an ascending array of numbers and sums them up in threads.


program fwsum;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Farmer in 'Farmer.pas',
  Abstraction in 'Abstraction.pas',
  Worker in 'Worker.pas',
  waste in 'waste.pas',
  Strings in 'Strings.pas';

function GetDefault(ADefault:integer):integer;
  //Reads a number from the standard input. If the read string is not
  //a suitable number, it returns ADefault.

var s:string;
    i:integer;

begin
  readln(s);
  val(s, result, i);
  if (i<>0) or (result<1) then result:=ADefault;
end;

var ValuesCount, WorkersCount, WasteLevel, i:integer;
    Farmer:TFarmer;
    tmp:Double;


begin
  //Ask for the input parameters
  write(Format(rsEnterValuesSize, [dfValuesSize]));
  ValuesCount:=GetDefault(dfValuesSize);
  write(Format(rsEnterWorkersCount, [dfWorkersCount]));
  WorkersCount:=GetDefault(dfWorkersCount);
  write(Format(rsEnterWastingLevel, [dfWastingLevel]));
  WasteLevel:=GetDefault(dfWastingLevel);


  //Create the farmer
  writeln(rsCreatingFarmer);
  writeln(rsGeneratingValues);
  Farmer:=TFarmer.Create(ValuesCount);

  //Create workers and let them work
  writeln(rsEmployingWorkers);
  for i := 1 to WorkersCount do
    TWorker.Create(Farmer, WasteLevel);
      //Each worker will free itself on exit, so we don't have to remeber
      //the pointers to free the memory.

  //Wait, until all workers had done their jobs.
  Farmer.WaitForWorkers;

  //Display the output.
  tmp:=Farmer.Sum; //just to fool the Format routine
  writeln(Format(rsTotalSum, [tmp]));

  //And release the farmer as well.
  Farmer.Free;

  //For a convenience, wait for the readln, when running from windowed IDE.
  writeln(rsPressEnter);
  readln;
end.
